/*
   Send dynamic IP via email to addressee of your choice.
   Some ISP's allow you to keep a line up 24 hours/day with
   the caviat that you drop the line at least once in that
   period -- this prog allows that to happen while keeping you
   advised of the new IP on reconnecting so you can always reach
   your private site from work or school or where ever.

   Run this from a cron job once a day or however often your ISP
   requires.

   From: Dennis Peterson
   Free to the world
*/

signal on halt name CLEANUP

outfile = 'new_ip.addr'
rc=SysFileDelete(outfile)

/* Use your favorite means to restart your PPP/SLIP session */
'restart_PPP'

/* let's create a queue for the new IP */
newq = RxQueue("create")
RC = RxQueue('set', newq)

/* I use ksh because of the elegance shown. Hostname is executed and
   the result is given to ping as an argument. This way you get your
   new host name as well as your new IP. I leave it to you to determine
   how to handle an error here (for example, if your connection is down).
*/
'@ksh -c "ping `hostname` 56 1" | rxqueue' newq

/*
   If you don't have ksh (ask yourself why!)
'@hostname | rxqueue' newq
*/

/* set up the address lists */
From = 'dpeterso@halcyon.com (Dennis Peterson)'
Reply_to = 'dpeterso@halcyon.com (Dennis Peterson)'

To = "dennispe@midsea.com"
CC = ""
Subject = "Today's New IP"

/* now get the time and date and bundle all the header info into
   an RFC822 format for sendmail
*/
parse value date() with today month year
Day = Left(date('W'),3)
year = right(year,2)
parse value time('L') with hour':'minutes':'seconds'.'hundredths

rc=lineout(outfile, 'Date: '|| Left(date('W'),3) ||', '||,
     today month year hour || ':' ||,
     minutes || ':' ||,
     seconds || ':' ||,
     Left(hundredths,2) 'PST8PDT')

rc=lineout(outfile,'From: ' || From)
rc=lineout(outfile,'Reply-to: ' || Reply_to)
rc=lineout(outfile,'To: ' || to)
rc=lineout(outfile,'CC: ' || CC)
rc=lineout(outfile,'Subject: ' || subject);rc=lineout(outfile,"")

Do While Queued() >< 0
   pull in_a_line
   rc=lineout(outfile, in_a_line)
end

call RXQueue "delete", newq

/* now send it off */
'sendmail -a outfile -t'

CLEANUP:
exit  /* Rexx */
